// Author: A.Voss@FH-Aachen.de
//
// bits and operators, fast eval
// tags: bits

#include <iostream>
#include <cstdlib>
using namespace std;

#include "../../include/tools.h"

class C
{
public:
    int n=23;
    
    operator bool() const { 
        tools_log(); cout << "op bool, n=" << n << endl;
        return n>0; 
    } 
    
};

int main()
{
    tools_log(); cout << "some operations..." << endl;

    int* p=nullptr;
    
    if (nullptr!=p && *p==12) { // *p eval.? -> short eval., first expr. is false
        tools_log(); cout << "oops" << endl;
    }

    if (2>1 || *p==12) {        // *p eval.? -> short eval, first expr. is true
        tools_log(); cout << "2>1 ... juhuu" << endl;
    }
    
    C c1,c2;
    if (c1 || c2) {             // short eval works
        tools_log(); cout << "only c1 is evaluated" << endl;
    }

    int n;
    
    n = 1 << 3;     // *2^3
    tools_log(); cout << "bit shift <<, n=" << n << endl;
    
    n = n >> 2;     // /2^2         same as n>>=2
    tools_log(); cout << "bit shift >>, n=" << n << endl;
    
    n = n | 4;      // set bit 2^2  same as n|=4;
    tools_log(); cout << "bit set,      n=" << n << endl;
    
    n = 15;         // this 0b1111
    int mask = ~6;  // bit-wise invert, i.e. ~(0..0110) = 1..1001
    n = n & mask;   // clear bits 2^2 and 2^1   same as n &= mask
    tools_log(); cout << "bit clear,    n=" << n << endl;

    n = 6;          //     0b0110
    n = n^3;        // xor 0b0011 = 0b0101  same as n^=3
    tools_log(); cout << "bit xor,      n=" << n << endl;
    
    return EXIT_SUCCESS;
}

